/*************************************************
 **                                             **
 **   eval.h                                    **
 **                                             **
 **       SoftC expression evaluator header     **
 **                                             **
 **          Copyright (C) 1991-1992 by         **
 **               SoftC, Ltd.                   **
 **               16820 Third Street NE         **
 **               Anoka, MN 55304               **
 **               (612) 434-6968                **
 **                                             **
 **             All rights reserved.            **
 *************************************************/



/**********
 *
 *  Type Definitions
 *
 **********/


typedef struct {
  CHAR F_PTR eval;    /* expression value */
  SHORT etyp;         /*            type */
  SHORT elen;         /*            length */
} SC_EVALP;

typedef struct {
  SC_BFR fval;        /* data field value */
  SHORT ftyp;         /*            type */
  SHORT flen;         /*            length */
  CHAR F_PTR xprsn;   /* expression processed pointer */
} SC_EVALF;


#ifdef _Windows
typedef INT FAR PASCAL (*PTEF)(SC_EVALF F_PTR); /* user function */
#else
#ifdef __ANSI_PROTOTYPES__
typedef INT (*PTEF)(SC_EVALF F_PTR);  /* user's expression evaluation function */
#else
typedef INT (*PTEF)();  /* user's expression evaluation function */
#endif
#endif



/**********
 *
 *  Expression Evaluation Prototypes
 *
 **********/



#ifdef __ANSI_PROTOTYPES__
#ifdef __cplusplus
extern "C" {
#endif

INT PROTOS scdxadd(   CHAR F_PTR,         /* evaluation string */
		      PTEF );             /* evaluation function */

INT PROTOS scdxdel(   CHAR F_PTR );       /* evaluation string */

INT PROTOS scdxeval(  INT,                /* data file handle */
		      CHAR F_PTR,         /* index expression */
		      SC_EVALP F_PTR );   /* eval structure address */

INT PROTOS scdxinfo(  INT F_PTR,          /* total number of evaluators */
		      INT F_PTR );        /* length of longest string */

INT PROTOS scdxlist(  CHAR F_PTR,         /* evaluation string */
		      INT );              /* expression number */

INT PROTOS scdxproc(  VOID );             /* process expression */

INT PROTOS scdxvget(  SHORT F_PTR );      /* get variable from expression */

#ifdef __cplusplus
}
#endif
#endif





